<?php
 
require_once($_SERVER['DOCUMENT_ROOT'] . '/sys/db.php');

class modProject {

  private $pw_id;
  private $pa_id;
  private $today;
  private $start_time;
  private $end_time;
  private $break_duration;
  private $parcel_id;
  private $parcel_name;
  private $project_id;
  private $project_name;
  private $workday_id;
  private $date;
  private $status;
  private $hour_list;
  private $min_list;
  private $workdays;
  private $form_defs;

  public function __construct($pw_id, $pr_id) {
    if (isset($pw_id))
      $this->pw_id = $pw_id;
    else 
      $this->pw_id = 0;

    if (isset($pr_id))
      $this->pr_id = $pr_id;
    else 
      $this->pr_id = 0;
    
    $this->today = date("Y-m-d");
    $this->today_text = date("D M j, Y");
    $this->min_list  = "00,15,30,45";
    $this->frac_list  = "00,25,50,75";
    $start_time      = "08:30";
    $end_time        = "17:00";
    $break_dur       = "00:50";

    $dal = new DAL();
    
    $sql = "SELECT CI.instance AS fieldname, CE.value AS label, " .
           "0 AS newValue, 0 AS dbValue, '' AS newText, '' AS dbText, " .
           "CF.mandatory, CF.uniquekey, CF.confirm  " .
           "FROM controlinstance CI, controlentry CE, controlform CF " .
           "WHERE CE.controlinstance_id = CI.id AND CE.property = 'label' " .
           "AND CF.controlinstance_id = CI.id AND CF.formhandler_id = " .
           "(SELECT FH.id FROM controlinstance FH " .
           "WHERE FH.instance = 'putFieldProject') ";
    $this->formdata = $dal->query($sql);    
 
    $sql = "SELECT PW.id, PR.name AS Project, PR.refno AS 'Ref No', " .
           "PA.name AS Parcel, WO.textdate AS Workday, " .
           "CONCAT (FW.start_time, '-', FW.end_time) AS Time "  .
           "FROM projectworkday PW, fieldworkday FW, " .
           "workday WO, parcel PA, project PR " .
           "WHERE PR.id = $this->pr_id AND PA.project_id = PR.id " .
           "AND PW.parcel_id = PA.id AND FW.projectworkday_id = PW.id " .
           "AND WO.id = PW.workday_id " .
           "ORDER BY WO.date DESC";
    $this->workdays = $dal->query($sql);

    if (count($this->workdays) == 0) {

      $default = array('1' => array("pw_id"=>"0", "Project"=>"", "Ref No"=>"",
                                    "Parcel"=>"", "Workday"=>"", "Time"=>""));
      $this->workdays = $this->toObject ($default);
    }

    $sql = "SELECT PA.id, PA.name as text " .
           "FROM parcel PA " .
           "WHERE PA.project_id  = " .
           "(SELECT PA.project_id " .
           "FROM projectworkday PW, parcel PA " .
           "WHERE PW.id = $this->pw_id AND PA.id = PW.parcel_id) " ;
    $this->parcelList = $dal->query($sql);
  
    $default = array("putFieldProject"=>0,
      "livFieldProject"=>0, "livFieldProject_text"=>"",
      "selProjParcel"=>0, "selProjParcel_text"=>"",
      "selWorkDate"=>$this->today, "selWorkDate_text"=>$this->today_text,
      "selStartTime"=>$start_time, "selStartTime_text"=>$start_time,
      "selEndTime"=>$end_time, "selEndTime_text"=>$end_time,
      "selBreakDur"=>$break_dur, "selBreakDu_text"=>$break_dur);
    $this->form_defs = $this->toObject ($default);
  }
  
  public function get($prop) {
    return $this->$prop;
  }

  private function toObject($array) {
    $object = new stdClass();
    foreach ($array as $key => $value) {
      if (is_array($value)) {
        $value = $this->toObject($value);
      }
      $object->$key = $value;
    }
    return $object;
  }
  
}

?>
